#include <bits/stdc++.h>
#define endl '\n'

#pragma GCC optimze("O3")

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0; }
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0; }
const int MAXN = 100;

random_device rd;
mt19937 mt(rd());

int n, k;
int p[MAXN]; 

void read()
{
	cin >> n >> k;
	for(int i = 1; i <= n; i++)
		cin >> p[i];
}

int used[MAXN];
vector<vector<int> > chains;
int in_deg[MAXN];
bool is_ok[MAXN];

int TIM = 27;

void solve()
{
	for(int i = 1; i <= n; i++) is_ok[i] = (k % i == 0);
	for(int i = 1; i <= n; i++) in_deg[p[i]] = 1;
	for(int i = 1; i <= n; i++)
		if(!used[i] && !in_deg[i])
		{
			int x = i;
			vector<int> ch;
			while(x != 0)
			{	
				used[x] = 1;
				ch.pb(x);
				x = p[x];
			}

			chains.pb(ch);
		}

	vector<int> perm(SZ(chains), 0);
	for(int i = 0; i < SZ(chains); i++)
		perm[i] = i;

	/*
	for(int i = 0; i < SZ(chains); i++)
	{
		cout << SZ(chains[i]) << ": ";
		for(int x: chains[i]) cout << x << " , ";
		cout << endl;
	}
	*/

	//clock_t ST = clock();
	//while((clock() - ST) < 0.35 * CLOCKS_PER_SEC)
	while(true)
	{
		shuffle(ALL(perm), mt);	
		
		//for(int i = 0; i < SZ(perm); i++)
		//	cout << perm[i] << " ";
		//cout << endl << flush;
		
		bool ok = true;
		TIM++;
		for(int i = 0; i < SZ(chains); i++)
			if(used[i] != TIM)
			{
				int sum = 0, x = i;
				while(used[x] != TIM)
				{
					used[x] = TIM;
					sum += SZ(chains[x]);
					x = perm[x];
				}

				if(!is_ok[sum])
				{
					ok = false;
					break;
				}
			}

		if(ok)
		{
			for(int i = 0; i < SZ(chains); i++)
				p[chains[i].back()] = chains[perm[i]][0];
			break;
		}	
	}

	for(int i = 1; i <= n; i++) cout << p[i] << " ";
	cout << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	read();
	solve();
	return 0;
}
