/*
Edin razmazan Dzhon
tseluva strastno Greta.
Po ustnite mu -
sladostna liga...
	S t i g a !

Kude e tuka nashata sudba?
Kude e dramata?
Kude sum az? Kazhete!
V gurdite ni opryan e za strelba
na vremeto barutno pistoleta.

Nima mozhem da lyubim
i da mrazim
s naivnata vi lekovernost?
Gurdite ni sa pulni s dim,
drobovete ni - s kaverni.
*/
#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>

std::vector<uint32_t> perm;
uint32_t k;

void input() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);
	//Look around, look around at how lucky we are to be alive right now!

	uint32_t n;
	std::cin >> n >> k;
	//Helpless
	perm.resize(n);

	for (uint32_t &i : perm) {
		//They're asking me to lead...
		std::cin >> i;
		if (i == 0) {
			i = perm.size();
		} else {
			i--;
		}
	}
	//You'll never be satisfied...
}

std::vector<uint32_t> segEnd; //only for starts (this is a ledgit comment, not a quote)
std::vector<std::vector<uint32_t>> indsByLen;

struct Len {
	uint32_t l;
	uint32_t f;
};

std::vector<Len> lens;
uint32_t fSum;

void decompose_perm() {
	//Angelica
	segEnd = std::vector<uint32_t>(perm.size(), perm.size());
	for (uint32_t i : perm) {
		if (i < perm.size()) {
			segEnd[i] = 0;
		}
	}

	//Eliza
	std::vector<uint32_t> lenList;
	indsByLen.resize(perm.size() + 1);
	for (uint32_t i = 0;i < perm.size();i++) {
		if (segEnd[i] == 0) {
			continue;
		}
		uint32_t l = 0;
		uint32_t j = i;
		while (true) {
			l++;

			if (perm[j] == perm.size()) {
				break;
			} else {
				j = perm[j];
			}
		}
		std::cerr << "start " << i << " end " << j << " len " << l << "\n";
		lenList.push_back(l);
		segEnd[i] = j;
		indsByLen[l].push_back(i);
		fSum++;
	}


	//and Peggy
	std::sort(lenList.begin(), lenList.end());
	uint32_t curCnt = 1;
	for (uint32_t i = lenList.size() - 1;i > 0;i--) {
		if (lenList[i] == lenList[i - 1]) {
			curCnt++;
		} else {
			lens.push_back({lenList[i], curCnt});
			curCnt = 1;
		}
	}
	lens.push_back({lenList[0], curCnt});
	for (const Len &l : lens) {
		std::cerr << "Len " << l.l << " x " << l.f << "\n";
	}
	for (uint32_t i : segEnd) {
		std::cerr << i << " ";
	}
	std::cerr << "\n";
}
const uint32_t MAX_N = 52;

bool okL[MAX_N];

void calc_ok_L() {
	for (uint32_t i = 1;i <= perm.size();i++) {
		okL[i] = k % i == 0;
	}
}

Len ans[MAX_N][MAX_N];
uint32_t ansL[MAX_N];

void print_raw_ans() {
	for (uint32_t i = 0;i < MAX_N;i++) {
		if (ans[i][0].f == 0) {
			break;
		}
		std::cerr << "(" << ans[i][0].l << " x " << ans[i][0].f << ")";
		for (uint32_t j = 1;j < MAX_N;j++) {
			if (ans[i][j].f == 0) {
				break;
			}
			std::cerr << " + (" << ans[i][j].l << " x " << ans[i][j].f << ")";
		}
		std::cerr << " = " << ansL[i] << "\n";
	}
}
bool find_ans(uint32_t setI, uint32_t entryI, uint32_t lenI) {
	if (lenI == lens.size()) {
		//std::cerr << "prelimenary ";
		//print_raw_ans();
		if (okL[ansL[setI]]) {
			if (fSum == 0) {
				return true;
			} else {
				return find_ans(setI + 1, 0, 0);
			}
		} else {
			return false;
		}
	}
	if ((entryI != 0) || (lens[lenI].f == 0)) {
		if (find_ans(setI, entryI, lenI + 1)) {
			return true;
		}
	}
	if (lens[lenI].f > 0) {
		for (uint32_t i = 1;i <= lens[lenI].f;i++) {
			ans[setI][entryI] = {lens[lenI].l, i};
			lens[lenI].f -= i;
			fSum -= i;
			ansL[setI] += i * lens[lenI].l;

			if (find_ans(setI, entryI + 1, lenI + 1)) {
				return true;
			} 

			ans[setI][entryI] = {0, 0};
			lens[lenI].f += i;
			fSum += i;
			ansL[setI] -= i * lens[lenI].l;
		}
	}
	return false;
}

uint32_t get_seg(uint32_t l) {
	uint32_t ans = indsByLen[l].back();
	indsByLen[l].pop_back();
	return ans;
}

void build_perm() {
	for (uint32_t i = 0;i < MAX_N;i++) {
		if (ans[i][0].f == 0) {
			break;
		}
		uint32_t start = get_seg(ans[i][0].l);
		uint32_t end = segEnd[start];
		for (uint32_t j = 1;j < ans[i][0].f;j++) {
			uint32_t curS = get_seg(ans[i][0].l);
			perm[end] = curS;
			end = segEnd[curS];
		}
		for (uint32_t j = 1;j < MAX_N;j++) {
			if (ans[i][j].f == 0) {
				break;
			}
			for (uint32_t k = 0;k < ans[i][j].f;k++) {
				uint32_t curS = get_seg(ans[i][j].l);
				perm[end] = curS;
				end = segEnd[curS];
			}
		}
		perm[end] = start;
		//std::cerr << " = " << ansL[i] << "\n";
	}
}

void print_perm() {
	for (const uint32_t &i : perm) {
		std::cout << i + 1 << " ";
	}
	std::cout << "\n";
}

int main() {
	input();
	decompose_perm();
	calc_ok_L();

	if (!find_ans(0, 0, 0)) {
		//while (true) {
			//std::cerr << "Treasury or State?\n";
		//}
	}
	//std::cout << "found " << find_ans(0, 0, 0) << "\n";
	print_raw_ans();
	build_perm();
	print_perm();


}
