#include<bits/stdc++.h>
using namespace std;
const double pi=acos(-1);
const int nmax=1.5e4+42;
int n,k;
double arr[nmax],output[nmax],help[nmax];

complex<double> my;

void fft(vector< complex<double> > &a,double sign)
{
    if(a.size()==1)return;

    int sz=a.size();
    vector< complex<double> > a0={},a1={};
    for(int i=0;i<sz;i++)
        if(i%2==0)a0.push_back(a[i]);
        else a1.push_back(a[i]);

    fft(a0,sign);
    fft(a1,sign);

    complex<double> mult={cos(sign*2*pi/sz),sin(sign*2*pi/sz)},now={1,0};
    /*
    cout<<"mult: "<<mult.real()<<" "<<mult.imag()<<endl;

    cout<<"a was: "<<endl;
    for(auto k:a)cout<<k.real()<<" "<<k.imag()<<endl;
    cout<<"---"<<endl;
    */
    for(int i=0;i<sz/2;i++)
    {
        a[i]=a0[i]+now*a1[i];
        now=now*mult;
    }

    for(int i=sz/2;i<sz;i++)
    {
        a[i]=a0[i-sz/2]+now*a1[i-sz/2];
        now=now*mult;
    }

    /*
    cout<<"a is: "<<endl;
    for(auto k:a)cout<<k.real()<<" "<<k.imag()<<endl;
    cout<<"---"<<endl;
    */
}
vector<double> mult(vector<double> a,vector<double> b)
{
    int sz=a.size()+b.size();
    while((sz&(sz-1)))sz++;

    while(a.size()<sz)a.push_back(0);
    while(b.size()<sz)b.push_back(0);

    vector< complex<double> > a_={},b_={};
    for(auto k:a)
        a_.push_back({k,0});

    for(auto k:b)
        b_.push_back({k,0});
    /*
    cout<<"a_: "<<endl;for(auto k:a_)cout<<k.real()<<" "<<k.imag()<<endl;
    cout<<"---"<<endl;
    cout<<"b_: "<<endl;for(auto k:b_)cout<<k.real()<<" "<<k.imag()<<endl;
    cout<<"---"<<endl;
    */
    fft(a_,1);

    //cout<<"fft a_:"<<endl;for(auto k:a_)cout<<k.real()<<" "<<k.imag()<<endl;

    fft(b_,1);

    for(int i=0;i<sz;i++)
        a_[i]=a_[i]*b_[i];

    fft(a_,-1);

    vector<double> ret={};
    for(int i=0;i<sz;i++)
        ret.push_back(a_[i].real()/sz);
    /*
    cout<<"ret: ";for(auto k:ret)cout<<k<<" ";cout<<endl;
    system("pause");
    */
    return ret;
}
int main()
{
/*
for(auto k:mult({0.1,1,1},{1,1.2}))cout<<k<<" ";cout<<endl;
return 0;
*/
cin>>n>>k;
for(int i=0;i<n;i++)cin>>arr[i];

output[0]=1;

while(k)
{
    if(k%2)
    {
        vector<double> arr_={},output_={};

        for(int i=0;i<n;i++)
            arr_.push_back(arr[i]);

        for(int i=0;i<n;i++)
            output_.push_back(output[i]);

        vector<double> help_=mult(arr_,output_);

        for(int i=0;i<n;i++)output[i]=0;

        for(int i=0;i<help_.size();i++)
            output[i%n]+=help_[i];
    }

        vector<double> arr_={};

        for(int i=0;i<n;i++)
            arr_.push_back(arr[i]);

        vector<double> help_=mult(arr_,arr_);

        for(int i=0;i<n;i++)arr[i]=0;

        for(int i=0;i<help_.size();i++)
            arr[i%n]+=help_[i];

    k=k/2;
}


for(int i=0;i<n;i++)printf("%.9f ",output[i]);
return 0;
}
/*
3 2
0.1 0.4 0.5
*/
