#include<bits/stdc++.h>
using namespace std;
const int nmax=5e4+42;
struct graph
{
    int n,m;
    vector< pair<int/*to*/,int/*cost*/> > adj[nmax];
};
struct edge
{
    int type;
    int x,y,c;
};
int parent[2][nmax];
int root(int id,int node)
{
    //cout<<id<<" "<<node<<" "<<parent[id][node]<<endl;
    if(parent[id][node]==node)return node;
    parent[id][node]=root(id,parent[id][node]);
    return parent[id][node];
}
vector< edge > active;

graph inp[2];
void read(int id)
{
    scanf("%i%i",&inp[id].n,&inp[id].m);
    int x,y,c;
    for(int i=1;i<=inp[id].m;i++)
    {
        scanf("%i%i%i",&x,&y,&c);
        inp[id].adj[x].push_back({y,c});
        inp[id].adj[y].push_back({x,c});
    }
}
long long dist[nmax];
priority_queue< pair<long long/*dist*/,int/*where*/> > pq,idle;
long long dij(int id)
{
    memset(dist,-1,sizeof(dist));
    pq=idle;
    pq.push({0,1});
    while(pq.size())
    {
         pair<long long/*dist*/,int/*where*/> now=pq.top();
         pq.pop();
         now.first=-now.first;
         if(dist[now.second]!=-1)continue;
         dist[now.second]=now.first;

         for(auto k:inp[id].adj[now.second])
            pq.push({-(now.first+k.second),k.first});
    }
    return dist[inp[id].n];
}
bool cmp(edge a,edge b)
{
    return a.c<b.c;
}
long long solve()
{
    for(int id=0;id<2;id++)
    {
        for(int i=1;i<=inp[id].n;i++)
            for(auto k:inp[id].adj[i])
            {
                edge now;
                now.type=id;
                now.x=i;
                now.y=k.first;
                now.c=k.second;
                active.push_back(now);
            }
    }

    sort(active.begin(),active.end(),cmp);
    /*
    cout<<"active: "<<endl;
    for(auto k:active)
        cout<<k.type<<" "<<k.x<<" "<<k.y<<" "<<k.c<<endl;
    */

    for(int t=0;t<2;t++)
        for(int i=1;i<nmax;i++)parent[t][i]=i;

    int mult[2]={inp[0].n,inp[1].n};

    long long ret=0;

    for(auto k:active)
    {
        /*
        cout<<k.type<<" "<<k.x<<" "<<k.y<<" "<<k.c<<endl;

        cout<<root(k.type,k.x)<<endl;
        cout<<root(k.type,k.y)<<endl;
        */
        if(root(k.type,k.x)!=root(k.type,k.y))
        {
            parent[k.type][root(k.type,k.x)]=root(k.type,k.y);
            ret=ret+1LL*mult[!k.type]*k.c;
            mult[k.type]--;
        }
    }
    return ret;
}
int main()
{
int type;
scanf("%i",&type);

read(0);
read(1);

if(type==1)
{
    printf("%lld\n",dij(0)+dij(1));
    return 0;
}

printf("%lld\n",solve());
return 0;
}
/*
1
3 2
2 1 15
3 1 14
3 2
2 1 15
3 2 15

2
3 2
2 1 15
3 1 14
3 2
2 1 15
3 2 15
*/
