#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 55;

int n, k, p[N];
bool have[N];
vector < vector < int > > chains;
vector < pair < int, int > > v;
bool used[N], state[N];
int which[N];

vector < int > get_chain(int start) {
  int curr = start;
  vector < int > ans;

  do {
    ans.push_back(curr);
    curr = p[curr];
  } while(curr);

  return ans;
}

int recurse(int pos) {
  if(pos>=(int)(v.size())) {
    return true;
  }

  if(used[pos]) {
    return state[pos];
  }

  used[pos] = true;

  int i, sum = 0;

  for(i=pos;i<(int)(v.size());i++) {
    sum += v[i].first;

    if(k%sum==0) {
      if(recurse(i + 1)) {
        which[pos] = i;
        return state[pos] = true;
      }
    }
  }

  return state[pos] = false;
}

void restore() {
  int pos = 0;

  while(pos<(int)(v.size())) {
    int i;

    vector < int > idx;

    for(i=pos;i<=which[pos];i++) {
      idx.push_back(v[i].second);
    }
    idx.push_back(v[pos].second);

    for(i=0;i+1<(int)(idx.size());i++) {
      p[chains[idx[i]].back()] = chains[idx[i + 1]][0];
    }

    pos = which[pos] + 1;
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i, j;

  cin>>n>>k;
  for(i=1;i<=n;i++) {
    cin>>p[i];
    have[p[i]] = true;
  }

  for(i=1;i<=n;i++) {
    if(!have[i]) {
      chains.push_back(get_chain(i));
    }
  }

#ifdef Extazy
  printf("Chains: %d\n", (int)(chains.size()));
  for(i=0;i<(int)(chains.size());i++) {
    for(j=0;j<(int)(chains[i].size());j++) {
      printf("%d ", chains[i][j]);
    }
    printf("\n");
  }
#endif

  for(i=0;i<(int)(chains.size());i++) {
    v.push_back(make_pair((int)(chains[i].size()), i));
  }

  while(true) {
    random_shuffle(v.begin(), v.end());
    
    memset(used, 0, sizeof(used));

    if(recurse(0)) {
      restore();
      break;
    }
  }

  for(i=1;i<=n;i++) {
    if(i>1) printf(" ");
    printf("%d", p[i]);
  }
  printf("\n");

  return 0;
}
