#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 50007;

int type, n1, m1, n2, m2, in[N];
queue < int > q;
vector < pair < int, int > > v[N];
long long dist[N];

int get_code(int x, int y) {
  return (y-1) * n1 + x;
}

void add_edge(int x, int y, int z) {
  v[x].push_back(make_pair(y, z));
  v[y].push_back(make_pair(x, z));
}

void spfa() {
  int curr, i;

  fill(dist, dist + N, numeric_limits < long long >::max());

  dist[get_code(1, 1)] = 0;
  q.push(get_code(1, 1));
  in[get_code(1, 1)] = true;

  while(!q.empty()) {
    curr = q.front();
    q.pop();
    in[curr] = false;

    for(i=0;i<(int)(v[curr].size());i++) {
      long long d = dist[curr] + v[curr][i].second;

      if(d<dist[v[curr][i].first]) {
        dist[v[curr][i].first] = d;

        if(!in[v[curr][i].first]) {
          q.push(v[curr][i].first);
          in[v[curr][i].first] = true;
        }
      }
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i, j, x, y, z;

  cin>>type;
  cin>>n1>>m1;
  n2 = 200;

  for(i=1;i<=m1;i++) {
    cin>>x>>y>>z;

    for(j=1;j<=n2;j++) {
      add_edge(get_code(x, j), get_code(y, j), z);
    }
  }

  cin>>n2>>m2;
  for(i=1;i<=m2;i++) {
    cin>>x>>y>>z;
    
    for(j=1;j<=n1;j++) {
      add_edge(get_code(j, x), get_code(j, y), z);
    }
  }

  spfa();
  printf("%lld\n", dist[get_code(n1, n2)]);

  return 0;
}
