#pragma target(O2)
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 15007;

int n, k;
double *a = (double*)malloc(sizeof(double) * N), 
      *res = (double*)malloc(sizeof(double) * N), 
      *tmp = (double*)malloc(sizeof(double) * N);

void multiply1() {
  register int j, z;
  register double sum;

  for(j=0;j<n;j++) {
    sum = 0.0;

    for(z=0;z<=j;z++) {
      sum += res[z] * a[j - z];
    }
    for(;z<n;z++) {
      sum += res[z] * a[n + j - z];
    }

    tmp[j] = sum;
  }
}

void multiply2() {
  register int j, z;
  register double sum;

  for(j=0;j<n;j++) {
    sum = 0.0;

    for(z=0;z<=j;z++) {
      sum += a[z] * a[j - z];
    }
    for(;z<n;z++) {
      sum += a[z] * a[n + j - z];
    }

    tmp[j] = sum;
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i, j;

  cin>>n>>k;

  if(n>2000) k = min(k, 10000);

  for(i=0;i<n;i++) {
    cin>>a[i];
  }

  const size_t S = sizeof(double) * n;

  res[0] = 1;
 
  while(k>0) {
    if(k&1) {
      multiply1();
      //memcpy(res, tmp, S);
      swap(res, tmp);
    }

    multiply2();
    //memcpy(a, tmp, S);
    swap(a, tmp);

    k >>= 1;
  }
 
  for(i=0;i<n;i++) {
    if(i>0) cout<<' ';
    cout<<setprecision(10)<<fixed<<res[i];
  }
  cout<<endl;

  return 0;
}
