#include <bits/stdc++.h>
#define int long long
using namespace std;
int T, nx, mx, ny, my;
vector <pair <int, int> > g [50004][2];
bool used [50004][2];
long long path [50004][2];
void dejkstra (int a, int k){
	priority_queue <pair <long long, int> > pq;
	pq.push ({0, a});
	while (!pq.empty ()){
		auto p = pq.top ();
		pq.pop ();
		if (used [p.second][k]) continue;
		used [p.second][k] = 1;
		path [p.second][k] = -p.first;
		for (auto i : g [p.second][k]){
			if (used [i.first][k]) continue;
			pq.push ({p.first - i.second, i.first});
		}
	}
}
pair <int, pair <int, int> > ex [50004], ey [50004];
vector <long long> mstx, msty, sum;
vector <int> tree [50004][2];
int par [50004];
long long ans = 0ll;
signed main (){

	ios::sync_with_stdio (false);
	cin.tie (0);
	cout.tie (0);

	cin >> T;
	cin >> nx >> mx;
	for (int i = 0; i < mx; i ++){
		int u, v, w;
		cin >> u >> v >> w;
		ex [i] = {w, {u, v}};
		g [u][0].push_back ({v, w});
		g [v][0].push_back ({u, w});
	}
	cin >> ny >> my;
	for (int i = 0; i < my; i ++){
		int u, v, w;
		cin >> u >> v >> w;
		ey [i] = {w, {u, v}};
		g [u][1].push_back ({v, w});
		g [v][1].push_back ({u, w});
	}
	if (T == 1){
		dejkstra (1, 0);
		dejkstra (1, 1);
		cout << path [nx][0] + path [ny][1] << '\n';
		return 0;
	}

	sort (ex, ex + mx);
	sum.push_back (0ll);
	for (int i = 1; i <=nx; i ++) par [i] = i;
	for (int i = 0; i < mx; i ++){
		int u, v, w;
		u = ex[i].second.second;
		v = ex[i].second.first;
		w = ex[i].first;
		if (par [u] == par [v]) continue;
		mstx.push_back (w);
		sum.push_back (*(sum.end () - 1) + w);
		ans +=ny * w;
		u = par [u];
		v = par [v];
		if (tree [u][0].size () < tree [v][0].size ()) swap (u, v);
		for (int j : tree [v][0]){
			tree [u][0].push_back (j);
			par [j] = u;
		}
		tree [v][0].clear ();
	}
	sort (ey, ey + my);
	for (int i = 0; i < ny; i ++) par [i] = i;
	for (int i = 0; i < my; i ++){
		int u, v, w;
		u = ey[i].second.second;
		v = ey[i].second.first;
		w = ey[i].first;
		if (par [u] == par [v]) continue;
		msty.push_back (w);
		auto it = upper_bound (mstx.begin (), mstx.end (), w);
		ans -= sum [nx - 1] - sum [it - mstx.begin ()];
		ans += (mstx.end () - it + 1)*w;
		u = par [u];
		v = par [v];
		if (tree [u][1].size () < tree [v][1].size ()) swap (u, v);
		for (int j : tree [v][1]){
			tree [u][1].push_back (j);
			par [j] = u;
		}
		tree [v][1].clear ();
	}
	cout << ans << '\n';

	return 0;
}
