#include <bits/stdc++.h>

using namespace std;

const int N = 57;

int p[N], p2[N];
bool used[N];
vector<int> v;
int n, k;

int dfs(int u){
    used[u] = true;

    int ans = 1;

    if(!used[p2[u]]){
        ans += dfs(p2[u]);
    }

    return ans;
}

bool check(){
    for(int i = 1; i <= n; i++){
        used[i] = false;
    }

    for(int i = 1; i <= n; i++){
        if(!used[i]){
            int cnt = dfs(i);

            if(k % cnt != 0){
                return false;
            }
        }
    }
}

void fill_empty(){
    int j = 0;

    for(int i = 1; i <= n; i++){
        if(p[i]){
            p2[i] = p[i];
        }
        else{
            p2[i] = v[j];
            j++;
        }
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    srand(3);

    cin >> n >> k;

    for(int i = 1; i <= n; i++){
        cin >> p[i];

        if(p[i]){
            used[p[i]] = true;
        }
    }

    for(int i = 1; i <= n; i++){
        if(!used[i]){
            v.push_back(i);
        }
    }

    while(true){
        fill_empty();
        bool ok = check();

        if(ok){
            for(int i = 1; i <= n; i++){
                cout << p2[i] << " ";
            }
            cout << "\n";

            return 0;
        }

        random_shuffle(v.begin(), v.end());
    }

    return 0;
}
/*
11 42
0 0 9 10 6 1 3 0 11 2 0
*/
