#include <bits/stdc++.h>

using namespace std;

const int N = 57;

int p[N], p2[N];
bool used[N], usedv[N];
vector<int> v;
int n, k;

bool dfs(int u, int cnt){
    used[u] = true;
    cnt++;

    if(p2[u]){
        if(used[p2[u]]){
            if(k % cnt != 0){
                used[u] = false;
                return false;
            }
            else{
                return true;
            }
        }

        if(dfs(p2[u], cnt)){
            return true;
        }

        used[u] = false;

        return false;
    }

    for(int x: v){
        if(usedv[x]){
            continue;
        }

        p2[u] = x;
        usedv[x] = true;

        if(used[x]){
            if(k % cnt != 0){
                p2[u] = 0;
                usedv[x] = false;
                continue;
            }
            else{
                return true;
            }
        }

        if(dfs(x, cnt)){
            return true;
        }

        p2[u] = 0;
        usedv[x] = false;
    }

    used[u] = false;
    return false;
}

void solve(){
    while(true){
        random_shuffle(v.begin(), v.end());
        for(int i = 1; i <= n; i++){
            used[i] = false;
            usedv[i] = false;
            p2[i] = p[i];
        }

        int i;
        for(i = 1; i <= n; i++){
            if(!used[i]){
                bool ok = dfs(i, 0);

                if(!ok){
                    break;
                }
            }
        }

        if(i > n){
            break;
        }
    }

    for(int i = 1; i <= n; i++){
        cout << p2[i] << " ";
    }
    cout << "\n";
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    srand(3);

    cin >> n >> k;

    for(int i = 1; i <= n; i++){
        cin >> p[i];

        if(p[i]){
            used[p[i]] = true;
        }
    }

    for(int i = 1; i <= n; i++){
        if(!used[i]){
            v.push_back(i);
        }
    }

    solve();

    return 0;
}
/*
11 42
0 0 9 10 6 1 3 0 11 2 0
*/
