#include <bits/stdc++.h>

using namespace std;

const int N = 57;

int p[N], p2[N];
bool used[N], usedv[N], del[N], used2[N];
vector<int> v;
int n, k;

int l, mn_d[N];

bool dfs(int u, int cnt){
    used[u] = true;
    cnt++;
    l--;

    //cout << u << " " << cnt << " " << l << " " << mn_d[cnt] << endl;
    //cin.get();

    if(l + cnt < mn_d[cnt]){
        l++;
        used[u] = false;
        return false;
    }

    if(p2[u]){
        if(used[p2[u]]){
            if(!del[cnt]){
                used[u] = false;
                l++;
                return false;
            }
            else{
                return true;
            }
        }

        if(dfs(p2[u], cnt)){
            return true;
        }

        used[u] = false;
        l++;
        return false;
    }

    random_shuffle(v.begin(), v.end());

    for(int x: v){
        if(usedv[x]){
            continue;
        }

        p2[u] = x;
        usedv[x] = true;

        if(used[x]){
            if(!del[cnt]){
                p2[u] = 0;
                usedv[x] = false;
                continue;
            }
            else{
                return true;
            }
        }

        if(dfs(x, cnt)){
            return true;
        }

        p2[u] = 0;
        usedv[x] = false;
    }

    used[u] = false;
    l++;
    return false;
}

vector<int> cycle;
bool used3[N];

void dfs2(int u){
    //cout << u << " u" << endl;

    used[u] = true;
    cycle.push_back(u);

    if(!p[u]){
        return;
    }

    if(!used[p[u]]){
        dfs2(p[u]);
    }
}

void solve(){
    int l_cnt = n;

    for(int i = 1; i <= n; i++){
        used[i] = false;
    }

    for(int i = 1; i <= n; i++){
        if(!used[i]){
            if(!p[i]){
                used3[i] = true;
                continue;
            }

            cycle.clear();
            dfs2(i);

            //cout << i << " " <<cycle.back() << endl;

            if(p[cycle.back()] && !used3[p[cycle.back()]]){
                for(int x: cycle){
                    used2[x] = true;
                    l_cnt--;
                    //cout << x << " ";
                }
                //cout << endl;
            }
            else{
                for(int x: cycle){
                    used3[x] = true;
                }
            }
        }
    }

    /*cout << l_cnt << endl;
    for(int i = 1; i <= n; i++){
        cout << used2[i] << " ";
    }
    cout << endl;*/

    while(true){
        random_shuffle(v.begin(), v.end());
        l = l_cnt;
        for(int i = 1; i <= n; i++){
            used[i] = used2[i];
            usedv[i] = false;
            p2[i] = p[i];
        }

        int i;
        for(i = 0; i < (int)v.size(); i++){
            if(!used[v[i]]){
                bool ok = dfs(v[i], 0);

                if(!ok){
                    break;
                }
            }
        }

        if(i >= (int)v.size()){
            break;
        }
    }

    for(int i = 1; i <= n; i++){
        cout << p2[i] << " ";
    }
    cout << "\n";
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    srand(10);

    cin >> n >> k;

    for(int i = 1; i <= n; i++){
        cin >> p[i];

        if(p[i]){
            used[p[i]] = true;
        }
    }


    for(int i = n; i >= 1; i--){
        if(k % i == 0){
            del[i] = true;
        }
    }

    if(del[n]){
        mn_d[n] = n;
    }
    else{
        mn_d[n] = 1000;
    }
    for(int i = n - 1; i >= 1; i--){
        mn_d[i] = mn_d[i + 1];
        if(del[i]){
            mn_d[i] = i;
            //cout << i << endl;
        }
    }

    for(int i = 1; i <= n; i++){
        if(!used[i]){
            v.push_back(i);
        }
    }

    solve();

    return 0;
}
/*
11 42
0 0 9 10 6 1 3 0 11 2 0
*/
