#include<iostream>
#include<vector>
#include<queue>
using namespace std;
const long long maxn = 50000;

long long nx, ny;
long long mx, my;
long long subtask;
vector<pair<long long,long long> > ex[maxn], ey[maxn];

bool visx[maxn], visy[maxn];

void solve1()
{
    priority_queue<pair<long long,long long> > q;
    /// X
    q.push({0,0});
    long long ans = 0;
    while(!q.empty())
    {
        pair<long long,long long> t;
        t = q.top();
        q.pop();
        if(visx[t.second])  continue;
        visx[t.second] = true;
        if(t.second == nx - 1)
        {
            ans += -t.first;
            break;
        }
        for(long long j = 0; j < ex[t.second].size(); j ++)
        {
            pair<long long,long long> i = ex[t.second][j];
            if(!visx[i.first])
            {
                q.push({t.first - i.second, i.first});
            }
        }
    }

    /// Y
    while(!q.empty())   q.pop();
    q.push({0,0});
    while(!q.empty())
    {
        pair<long long,long long> t;
        t = q.top();
        q.pop();
        if(visy[t.second])  continue;
        visy[t.second] = true;
        if(t.second == ny - 1)
        {
            ans += -t.first;
            break;
        }
        for(long long j = 0; j < ey[t.second].size(); j ++)
        {
            pair<long long,long long> i = ey[t.second][j];
            if(!visy[i.first])
            {
                q.push({t.first - i.second, i.first});
            }
        }
    }
    cout << ans;

}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> subtask;
    cin >> nx >> mx;
    for(long long i = 0; i < mx; i ++)
    {
        long long a, b, d;
        cin >> a >> b >> d;
        a --; b --;
        ex[a].push_back({b, d});
        ex[b].push_back({a, d});
    }
    cin >> ny >> my;
    for(long long i = 0; i < my; i ++)
    {
        long long a, b, d;
        cin >> a >> b >> d;
        a --; b --;
        ey[a].push_back({b, d});
        ey[b].push_back({a, d});
    }
    solve1();
}
/**
1
3 2
2 1 15
3 1 14
3 2
2 1 15
3 2 15
*/
