#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
using namespace std;

const int MAXN = 64;

int n, k;
int a[MAXN], b[MAXN];

int us[MAXN];

vector<int> del;
vector<int> chain[MAXN], pred[MAXN], empt;
vector<pair<int, int>> chsz;

void Init()
{
    cin >> n >> k;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        b[i] = a[i];
        pred[a[i]].push_back(i);
    }

    int i = 1;
    for (i = 1; i * i < k; ++ i)
    {
        if (i > MAXN) break;
        if (k % i == 0)
        {
            del.push_back(i);
            del.push_back(k / i);
        }
    }
    if (i * i == k)
    {
        del.push_back(i);
    }

    sort(del.begin(), del.end());
}

int dp[MAXN];

bool DP()
{
    for (int i = 0; i < MAXN; ++ i)
    {
        dp[i] = 0;
    }

    bool notfin = 0;
    for (int i = 0; i < chsz.size(); ++ i)
    {
        if (us[chsz[i].second]) continue;
        notfin = 1;
        for (int j = MAXN - 1; j >= chsz[i].first; -- j)
        {
            if (dp[j - chsz[i].first] != 0 or j == chsz[i].first)
            {
                dp[j] = chsz[i].first;
            }
        }
    }
    return notfin;
}

int main()
{
    Init();

    /*for (int i = 0; i < del.size(); ++ i)
    {
        cout << del[i] << ' ' ;
    }
    cout << endl;*/

    for (int i = 1; i <= n; ++ i)
    {
        if (pred[i].size() == 0)
        {
            if (a[i] == 0)
            {
                empt.push_back(i);
                //cout << "empt: " << i << endl;
                continue;
            }

           // cout << "chain: " ;
            int x = i;
            while (x != 0)
            {
                chain[i].push_back(x);
           //     cout << x << ' ';
                x = a[x];

                if (x == i) break;
            }

         //   cout << endl;
            chsz.emplace_back(chain[i].size(), i);
        }
    }

    sort(chsz.begin(), chsz.end());

    while (true)
    {
        if (!DP()) break;

        int idx = del.size() - 1;
        int opt = 0, mint = 100;

       // cout << "ok "<< endl;

        for (int i = MAXN - 1; i > 0; -- i)
        {
            while (idx != 0 and del[idx - 1] >= i) idx--;

            if (dp[i] != 0 and del[idx] - i < mint)
            {
                mint = del[idx] - i;
                opt = i;
            }
        }

       // cout << "found " << opt << ' ' << "with mint " << mint << endl;

        vector<int> tmp, poss;
        int x = opt;
        while (x != 0)
        {
            //cout << dp[x]<< ' ' ;
            tmp.push_back(dp[x]);
            x -= dp[x];


        }

       // cout << endl;

        for (int i = 0; i < tmp.size(); ++ i)
        {
            for (int j = 1; j <= n; ++ j)
            {
                if (us[j] == 0 and chain[j].size() == tmp[i])
                {
                    poss.push_back(j);

                 //   cout <<  "ready : " <<j << endl;
                    us[j] = 1;
                    break;
                }
            }
        }

        for (int i = 0; i < poss.size(); ++ i)
        {
            if (i != poss.size() - 1) b[chain[poss[i]].back()] = chain[poss[i + 1]].front();
        }
        x = chain[poss.back()].back();
        for (int i = 1; i <= mint; ++ i)
        {
           // if (empt.size() == 0) while (true);
            b[x] = empt.back();
            empt.pop_back();
            x = b[x];
        }
        b[x]  = chain[poss.front()].front();
    }

    for (int i = 1; i <= n; ++ i)
    {
        if (b[i] == 0) cout << i << ' ';
        else cout << b[i] << ' ';
    }
    cout << endl;
    return 0;
}

/*
11 42
0 0 9 10 6 1 3 0 11 2 0
*/
