#include <iostream>
using namespace std;

const int MAXN = 15005;

int n, k;
long double a[MAXN], b[MAXN], c[MAXN], d[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;
    for (int i = 0; i < n; ++ i)
    {
        cin >> a[i];
        b[i] = a[i];
    }
}

int main()
{
    Init();

    d[0] = 1;
    int mask = 1;
    while (mask <= k)
    {
        if (mask & k)
        {
            for (int j = 0; j < n; ++ j)
            {
                for (int l = 0; l < n; ++ l)
                {
                    c[(j + l) % n] += d[j] * b[l];
                }
            }
            for (int j = 0; j < n; ++ j)
            {
                d[j] = c[j];
                c[j] = 0;
            }
        }

        for (int j = 0; j < n; ++ j)
        {
            for (int l = 0; l < n; ++ l)
            {
                c[(j + l) % n] += b[j] * b[l];
            }
        }

        for (int j = 0; j < n; ++ j)
        {
            b[j] = c[j];
            c[j] = 0;
        }

        mask <<= 1;
    }

    for (int i = 0; i < n; ++ i)
    {
        cout << d[i] << ' ';
    }

    cout << endl;
    return 0;
}

/*
3 2
0.1 0.4 0.5
*/

