#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 15003
using namespace std;
typedef long long ll;
typedef long double ld;
int n, k;
double p[MAXN];
void read()
{
    cin >> n >> k;
    for (int i = 1; i <= n; i++)
        cin >> p[i];
}
vector <vector <double> > mult(vector <vector <double> > a, vector <vector <double> > b)
{
    vector <vector <double> > ans;
    ans.resize(n + 1);
    for (int i = 1; i <= n; i++)
        ans[i].resize(n+1);
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
        for (int p = 1; p <= n; p++)
        ans[i][j] += a[i][p] * b[p][j];
        return ans;
}
vector <vector <double> > fast_pow(vector <vector <double> > a, int deg)
{
    if (deg == 1)
        return a;
    auto temp = fast_pow(a, deg / 2);
    auto ans = mult(temp, temp);
    if (deg & 1)
        ans = mult(ans, a);
    return ans;
}
void solve()
{
        if (n <= 100)
    {
        vector <vector <double> > v;
        v.resize(n+1);
        for (int i = 1; i <= n; i++)
        {
            v[i].resize(n+1);
            for (int j = 1; j <= n; j++)
            {
                int r = i - j;
                if (r < 0)
                    r += n;
                v[i][j] = p[r + 1];
            }
        }
        auto ans = fast_pow(v, k);
        /*for (auto i: ans)
        {
            for (auto j: i)
                cout << j << " ";
            cout << endl;
        }
        */
        cout << fixed;
        for (int i = 1; i <= n; i++)
            cout << setprecision(12) << ans[i][1] << " ";
        cout << endl;
    }
    else
        if (n <= 2003)
    {
        double dp[2003][303];
        if (k > 300)
        {
            cout << fixed;
            for (int i = 1; i <= n; i++)
                cout << setprecision(12) << 1.0 / n << " ";
            cout << endl;
            return;
        }
        for (int i = 1; i <= n; i++)
            dp[i][0] = 0;
        dp[1][0] = 1;
        for (int i = 1; i <= k; i++)
            for (int j = 1; j <= n; j++)
                for (int t = 1; t <= n; t++)
            {
                int r = j - t;
                if (r < 0)
                    r += n;
                dp[j][i] += dp[t][i-1] * p[r + 1];
            }
         cout << fixed;
         for (int i = 1; i <= n; i++)
            cout << setprecision(12) << dp[i][k] << " ";
         cout << endl;
    }

}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
