#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 15003
using namespace std;
typedef long long ll;
typedef long double ld;
int n, k;
double p[MAXN];
void read()
{
    cin >> n >> k;
    for (int i = 0; i < n; i++)
        cin >> p[i];
}
vector <double> mult(vector <double> &a, vector <double> &b)
{
    vector <double> ans;
    ans.resize(n);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
        ans[(i + j) % n] += a[i] * b[j];
    return ans;
}
vector <double> fast_pow(vector <double> &a, int deg)
{
    vector <double> ans = a;
    deg--;
    vector <double> c = a;
    while (deg)
    {
        if (deg & 1)
            ans = mult(ans, c);
        deg >>= 1;
        c = mult(c, c);
    }
    return ans;
}
void solve()
{
    if (n <= 2003)
    {
        vector <double> v;
        v.resize(n);
        for (int i = 0; i < n; i++)
            v[i] = p[i];
        auto ans = fast_pow(v, k);
        cout << fixed;
        for (int i = 0; i < n; i++)
            cout << setprecision(9) << ans[i] << " ";
        cout << endl;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
