#include <bits/stdc++.h>

const int32_t MAX_N = 50;

std::mt19937 mt(69);
bool hasIn[MAX_N + 5];

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int32_t n, k;
	std::cin >> n >> k;

	std::vector< int32_t > p(n + 1);
	for(int32_t i = 1; i <= n; i++) {
		std::cin >> p[i];
		
		hasIn[p[i]] = true;
	}
	
	std::vector< std::pair< int32_t, std::pair< int32_t, int32_t > > > a;
	for(int32_t i = 1; i <= n; i++) {
		if(!hasIn[i]) {
			int32_t cnt = 1, x = i;
			while(p[x] != 0) {
				x = p[x];
				cnt++;
			}

			a.push_back({ cnt, { i, x } });
		}
	}
	
	
	while(1) {
		std::shuffle(a.begin(), a.end(), mt);
		
		std::vector< int32_t > ans = p;

		bool isPos = true;
		int32_t sum = 0, first = -1;
		for(int32_t i = 0; i < a.size(); i++) {
			sum += a[i].first;

			if(first == -1) {
				first = a[i].second.first;
			}
			if(k % sum == 0) {
				sum = 0;
				ans[a[i].second.second] = first;
				first = -1;	
			}
			else {
				if(i == a.size() - 1) {
					isPos = false;
					break;
				}
				ans[a[i].second.second] = a[i + 1].second.first;
			}
		}

		if(isPos && sum == 0) {
			for(int32_t i = 1; i < ans.size(); i++) {
				std::cout << ans[i] << " ";
			}
			std::cout << '\n';
			return 0;
		}
	}
}
