#include <iostream>
#include <algorithm>
#include <cstdint>
#include <cstdlib>
#include <cmath>
#include <vector>
using namespace std;

uint32_t n, k;

vector<double> p, q;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n>>k;
    p.resize(n);
    q.resize(n);
    for(uint32_t i=0; i<n; i++)
        cin>>p[i];
}

void rec(uint16_t cur, uint8_t brh=0, double ch=1)
{
    //cout<<(uint16_t)cur<<' '<<(uint16_t)brh<<' '<<ch<<endl;
    if(brh==k)
    {
        q[cur]+=ch;
        return;
    }
    for(uint16_t i=0; i<p.size(); i++)
    {
        rec((cur+i)%n, brh+1, ch*p[i]);
    }
}

void solve()
{
    for(uint16_t i=0; i<n; i++)
        rec(i);
}

int main()
{
    init();
    rec(0);//solve();
    for(auto x:q)
        cout<<x<<' ';
    cout<<'\n';

    return 0;
}
