#include<bits/stdc++.h>
#define MUL 256
#define INF 2000000000
using namespace std;
int vx[201][201],vy[201][201],nx,mx,ny,my;
struct node
{
    int ver,price;
    bool operator < (const node &n) const
    {
        return price>n.price;
    }
};
struct edge
{
    int a,b,weight;
};
edge edges[256*256*2];
long long parent[256*256*2];
long long dd[256*256*2];
long long edgecnt,vertcnt;
vector<node> v[200*256+201];
int d[200*256+201];
priority_queue<node> q;
bool used[200*256+201];
void djonkstra()
{
    int s=MUL+1,f=ny*MUL+nx; int n=nx*ny;
    for(int i=1;i<=200*256+200;i++) d[i]=INF;
    d[s]=0;
    node curr;
    curr.ver=s; curr.price=0;
    q.push(curr);
    while(!q.empty())
    {
        curr=q.top();
        q.pop();
        if(d[curr.ver]>=curr.price)
        if(!used[curr.ver])
        {
            used[curr.ver]=1;
            int sz=v[curr.ver].size();
            for(int i=0;i<sz;i++)
            {
                node nb=v[curr.ver][i];
                if(nb.price+curr.price<d[nb.ver])
                {
                    d[nb.ver]=nb.price+curr.price;
                    nb.price=d[nb.ver];
                    q.push(nb);
                }
            }
        }
    }
    cout<<d[f]<<endl;
}
long long find(long long v)
{
    if(parent[v]==v) return v;
    return parent[v];
}
void merge(long long a,long long b)
{
    long long aroot=find(a),broot=find(b);
    if(d[aroot]<d[broot]) parent[aroot]=broot;
    else
    {
        if(d[broot]<d[aroot]) parent[broot]=aroot;
        else
        {
            parent[aroot]=broot;
            d[broot]++;
        }
    }
}
bool cmp(edge a,edge b){return a.weight<b.weight;}
long long kruskal()
{
    sort(edges,edges+edgecnt,cmp);
    long long sum=0;
    long long added=0;
    for(int i=0;i<256*256*2;i++) parent[i]=i;
    for(int i=0;i<edgecnt;i++)
    {
        //cout<<edges[i].a<<" "<<edges[i].b<<" "<<edges[i].weight<<endl;
        if(find(edges[i].a)!=find(edges[i].b))
        {
            merge(edges[i].a,edges[i].b); //cout<<edges[i].a<<" "<<edges[i].b<<endl;
            added++;
            sum+=edges[i].weight;
            if(added==vertcnt-1) break;
        }
    }
    return sum;
}
int main()
{
    ios_base::sync_with_stdio(0);
    int asd;
    cin>>asd;
    cin>>nx>>mx;
    for(int i=0;i<mx;i++)
    {
        int a,b,c;
        cin>>a>>b>>c;
        vx[a][b]=vx[b][a]=c;
    }
    cin>>ny>>my;
    for(int i=0;i<my;i++)
    {
        int a,b,c;
        cin>>a>>b>>c;
        vy[a][b]=vy[b][a]=c;
    }//cout<<"kur"<<endl;
    if(asd==1)
    {
        for(int i=1;i<=nx;i++)
        {
            for(int j=1;j<=ny;j++)
            {
                for(int k=1;k<=nx;k++)
                {
                    if(!vx[i][k]) continue;
                    int a=j*MUL+i,b=j*MUL+k;
                    node nud; nud.price=vx[i][k];
                    nud.ver=b;
                    v[a].push_back(nud);
                    nud.ver=a;
                    v[b].push_back(nud); //cout<<a<<" "<<b<<" "<<nud.price<<endl;
                }
                for(int k=1;k<=ny;k++)
                {
                    if(!vy[j][k]) continue;
                    int a=j*MUL+i,b=k*MUL+i;
                    node nud; nud.price=vy[j][k];
                    nud.ver=b;
                    v[a].push_back(nud);
                    nud.ver=a;
                    v[b].push_back(nud); //cout<<a<<" "<<b<<" "<<nud.price<<endl;
                }
            }
        }
        djonkstra();
    }
    else
    {
        vertcnt=nx*ny;
        edgecnt=nx*my+ny*mx; int br=0;
        for(int i=1;i<=nx;i++)
        {
            for(int j=1;j<=ny;j++)
            {
                for(int k=i+1;k<=nx;k++)
                {
                    if(!vx[i][k]) continue;
                    int a=j*MUL+i,b=j*MUL+k;
                    edges[br].a=a;
                    edges[br].b=b;
                    edges[br++].weight=vx[i][k];
                }
                for(int k=j+1;k<=ny;k++)
                {
                    if(!vy[j][k]) continue;
                    int a=j*MUL+i,b=k*MUL+i;
                    edges[br].a=a;
                    edges[br].b=b;
                    edges[br++].weight=vy[j][k];
                }
            }
        }edgecnt=br;
        cout<<kruskal()<<endl;
    }
    return 0;
}
/*

1
3 2
2 1 15
3 1 14
3 2
2 1 15
3 2 15

2
3 2
2 1 15
3 1 14
3 2
2 1 15
3 2 15

*/
