#include <bits/stdc++.h>

#define endl '\n'
#define trace(x) cerr << #x << " = " << x <<endl
#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXN = 1001;
const int MAXK = 101;

long double dp[MAXN][MAXK];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, k;
    cin >> n >> k;
    for (int i = 1; i <= n; i++) cin >> dp[i][1];

    for (int j = 2; j <= k; j++) {
        for (int i = 1; i <= n; i++) {
            dp[i][j] = 0.0;
            for (int k = 1; k <= n; k++) {
                int target = i;
                if (target < k) target += n;
                int offset = target - k;
                dp[i][j] += dp[k][j - 1] * dp[offset + 1][1];
            }
        }
    }

    for (int i = 1; i <= n; i++) cout << setprecision(2) << fixed << dp[i][k] << " \n"[i == n];

    return EXIT_SUCCESS;
}
