#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0; }
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0; }
const int MAXN = (1 << 20);

using base = complex<double>;
int n, k;

void fix(vector<double> &li)
{
	for(int i = SZ(li) - 1; i >= n; i--)
		li[i % n] += li[i];
	while(SZ(li) > n) li.pop_back();
}

base A[MAXN];
vector<double> initial;

void read()
{
	cin >> n >> k;
	initial.resize(n);
	for(double &v: initial)
		cin >> v;
}

vector<double> mult(const vector<double> &a, const vector<double> &b)
{
	vector<double> c(SZ(a) + SZ(b), 0);
	for(int i = 0; i < SZ(a); i++)
		for(int j = 0; j < SZ(b); j++)
			c[i + j] += a[i] * b[j];

	return c;
}

vector<double> f(const vector<double> &x, int p)
{
	if(p == 1) return x;

	if(p % 2)
	{
		auto it = mult(x, f(x, p - 1));
		fix(it);
		return it;
	}

	auto it = f(x, p / 2);
	it = mult(it, it);
	fix(it);
	return it;
}

void solve()
{
	initial = f(initial, k);
	for(double x: initial)
		cout << setprecision(9) << fixed << x << " ";
	cout << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	read();
	solve();
	return 0;
}
