/*
Toi ne ni e veche brat -
zhivite ot vragovete
murtva gi vulna pomete
neide kum otsreshtnii bryag.

Eto, v hlutnalya slog
legnal e spokoino bleden,
s primirena skrub zagledan
v svoda yasen i dulbok.

I po sivata zemq,
toplena ot laski yuzhni,
trepkat plahi i nenuzhni
s kruv napliskani pisma

Koi e toi i de e bil?
Chii go zov pri nas dovede
v den na vihreni pobedi
da umre, nepobedil?

Kleta maichina ruka,
ti li go v nevolya cherna
s dumi na lyubov bezmerna
uteshi i prilaska?

Smeshna zhal, nelepa zhal,
v grohotno zhestoko vreme!
Ne zhivot li da otneme,
toi zhivota svoi e dal?

I nima pod vrazhi styag
gotvil e za nas poshtada?
Ne, toi vze shto mu se pada,
murtviyat ne ni e vrag!
*/
#include <iostream>
#include <cstdint>
#include <vector>
#include <queue>

namespace Task1 {
	const uint64_t INF = 1ULL << 60;

	struct Vertex; 
	struct Edge {
		Vertex *to;
		uint32_t w;
	};

	struct Vertex {
		std::vector<Edge> edges;
		uint64_t dist;

		Vertex(): dist(INF) {}
	};

	struct QVert {
		uint64_t dist;
		Vertex *v;
		friend bool operator< (const QVert &a, const QVert &b) {
			return a.dist > b.dist;
		}
	};

	typedef std::vector<Vertex> Graph;
	Graph x, y;

	void read_graph(Graph &g) {
		uint32_t vCnt, eCnt;
		std::cin >> vCnt >> eCnt;

		g.resize(vCnt);
		for (uint32_t i = 0;i < eCnt;i++) {
			uint32_t u, v, w;
			std::cin >> u >> v >> w;

			u--;
			v--;

			g[u].edges.push_back({&g[v], w});
			g[v].edges.push_back({&g[u], w});
		}
	}
	uint64_t shortest_path(Graph &g) {
		std::priority_queue<QVert> next;
		g[0].dist = 0;
		next.push({0, &g[0]});

		while (!next.empty()) {
			auto p = next.top();
			next.pop();
			Vertex *v = p.v;
			if (p.dist != v->dist) {
				continue;
			}
			
			for (const Edge &e : v->edges) {
				uint64_t nDist = e.w + v->dist;
				if (nDist < e.to->dist) {
					e.to->dist = nDist;
					next.push({nDist, e.to});
				}
			}
		}
		return g.back().dist;
	}
	void solve() {
		read_graph(x);
		read_graph(y);
		std::cout << shortest_path(x) + shortest_path(y) << "\n";
	}
}

namespace Task2 {
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	uint32_t taskT;
	std::cin >> taskT;
}


