#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 15007;

int n, k;
double a[N], res[N], tmp[N];

inline double get(double *a, int i, int j) {
  return a[(j >= i) ? (j - i) : (j - i + n)];
}

inline void multiply1() {
  int j, z;

  for(j=0;j<n;j++) {
    double sum = 0.0;

    for(z=0;z<=j;z++) {
      sum += res[z] * a[j - z];
    }
    for(;z<n;z++) {
      sum += res[z] * a[n + j - z];
    }

    tmp[j] = sum;
  }
}

inline void multiply2() {
  int j, z;

  for(j=0;j<n;j++) {
    double sum = 0.0;

    for(z=0;z<=j;z++) {
      sum += a[z] * a[j - z];
    }
    for(;z<n;z++) {
      sum += a[z] * a[n + j - z];
    }

    tmp[j] = sum;
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i, j;

  cin>>n>>k;
  for(i=0;i<n;i++) {
    cin>>a[i];
  }

  const size_t S = sizeof(double) * n;

  res[0] = 1;
 
  while(k>0) {
    if(k&1) {
      multiply1();
      //memcpy(res, tmp, S);
      swap(res, tmp);
    }

    multiply2();
    //memcpy(a, tmp, S);
    swap(a, tmp);

    k >>= 1;
  }
 
  for(i=0;i<n;i++) {
    if(i>0) cout<<' ';
    cout<<setprecision(10)<<fixed<<res[i];
  }
  cout<<endl;

  return 0;
}
