#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 50007;
const long long INF = 1000000000000000007;

int type, n1, n2, m1, m2;
vector < pair < int, int > > v1[N], v2[N];
long long dist_g1_1[N], dist_g1_n[N], dist_g2_1[N], dist_g2_n[N];
bool in[N];
long long ans;

void spfa(int n, int start, long long *dist, vector < pair < int, int > > *v) {
  int curr, i;
	queue < int > q;

  fill(dist + 1, dist + 1 + n, numeric_limits < long long >::max());
	fill(in + 1, in + 1 + n, false);

  dist[start] = 0;
  q.push(start);
  in[start] = true;

  while(!q.empty()) {
    curr = q.front();
    q.pop();
    in[curr] = false;

    for(i=0;i<(int)(v[curr].size());i++) {
      long long d = dist[curr] + v[curr][i].second;

      if(d<dist[v[curr][i].first]) {
        dist[v[curr][i].first] = d;

        if(!in[v[curr][i].first]) {
          q.push(v[curr][i].first);
          in[v[curr][i].first] = true;
        }
      }
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i, x, y, z;

  scanf("%d", &type);
  
  scanf("%d %d", &n1, &m1);
  for(i=1;i<=m1;i++) {
    scanf("%d %d %d", &x, &y, &z);

    v1[x].push_back(make_pair(y, z));
    v1[y].push_back(make_pair(x, z));
  }

  scanf("%d %d", &n2, &m2);
  for(i=1;i<=m2;i++) {
    scanf("%d %d %d", &x, &y, &z);

    v2[x].push_back(make_pair(y, z));
    v2[y].push_back(make_pair(x, z));
  }

  spfa(n1, 1, dist_g1_1, v1);
  spfa(n1, n1, dist_g1_n, v1);
  spfa(n2, 1, dist_g2_1, v2);
  spfa(n2, n2, dist_g2_n, v2);

  ans = INF;
  
  for(i=1;i<=n1;i++) {
    ans = min(ans, dist_g1_1[i] + dist_g2_1[n2] + dist_g1_n[i]);
  }
  for(i=1;i<=n2;i++) {
    ans = min(ans, dist_g2_1[i] + dist_g1_1[n1] + dist_g2_n[i]);
  }

  printf("%lld\n", dist_g1_1[n1] + dist_g2_1[n2]);

  return 0;
}
