#include <bits/stdc++.h>
using namespace std;
int n, K;
vector <double> a (15005);
vector <double> mult (vector <double> x, vector <double> y){
	vector <double> z (n);
	for (int i = 0; i < n; i ++){
		for (int j = 0; j < n; j ++){
			z [(i + j) % n] += x [i] * y [j];
		}
	}
	return z;
}
vector <double> step (int k){
	if (k == 1) return a;
	vector <double> b = step (k >> 1);
	b = mult (b, b);
	if (k % 2 > 0) b = mult (b, a);
	return b;
}
int main (){

	ios::sync_with_stdio (false);
	cin.tie (0);
	cout.tie (0);

	cin >> n >> K;
	for (int i = 0; i < n; i ++){
		cin >> a [i];
	}
	vector <double> ans = step (K);
	for (auto i : ans) cout << fixed << setprecision (6) << i << ' ';
	cout << '\n';

	return 0;
}
