#include<iostream>
#include<vector>
#include<iomanip>
using namespace std;
int n, k;
const int maxn = 15000;

vector<double> prob;

vector<double> mul(vector<double> &v1, vector<double> &v2)
{
    vector<double> ans;
    ans.reserve(n);
    for(int i = 0; i < n; i ++) ans.push_back(0);
    for(int i = 0; i < n; i ++)
    {
        for(int j = 0; j < n; j ++)
        {
            ans[(i + j) % n] += v1[i] * v2[j];
        }
    }
    return ans;
}

void print(vector<double> &v)
{
    for(int i = 0; i < n; i ++)
    {

        cout << fixed << setprecision(7) << v[i] << " ";
    }
    cout << endl;
}

vector<double> pow(vector<double> v, int p)
{
    vector<double> t = v;
    vector<double> ans;
    for(int i = 0; i < n; i ++) ans.push_back(0);
    ans[0] = 1.;
    while(p != 0)
    {
        //print(ans);
        if(p % 2 == 1)  ans = mul(ans, t);
        t = mul(t, t);
        p /= 2;
    }
    return ans;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    prob.reserve(n);
    for(int i = 0; i < n; i ++)
    {
        double t;
        cin >> t;
        prob.push_back(t);
    }
    prob = pow(prob, k);
    print(prob);
}
/**
3 2
0.1 0.4 0.5
*/
