#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <iomanip>
#define pb push_back
#define mp make_pair
#define ll long long
using namespace std;
const int N = 1e3 + 5;
const int K = 1e2 + 5;

int n, k;
double p[N];

double dp[N][K];



int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;
    for(int i = 0; i < n; i++)
        cin >> p[i];

    dp[0][0] = 1;
    for(int step = 1; step <= k; step++)
    {
        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < n; j++)
            {
                int from = (n + i - j) % n;
                dp[i][step] += dp[from][step - 1] * p[j];
            }
        }
    }

    for(int i = 0; i < n; i++)
        cout << setprecision(6) << dp[i][k] << " ";
    cout << endl;


    return 0;
}


/*

3 2
0.1 0.4 0.5

*/
