#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 50003
#define INF 1000000000000000
using namespace std;
typedef long long ll;
typedef long double ld;
int task;
int nx, mx, ny, my;
vector <pair <int, int> > adjx[MAXN], adjy[MAXN];
void read()
{
    cin >> task;
    cin >> nx >> mx;
    for (int i = 1; i <= mx; i++)
    {
        int a, b, c;
        cin >> a >> b >> c;
        adjx[a].push_back({b, c});
        adjx[b].push_back({a, c});
    }
    cin >> ny >> my;
    for (int i = 1; i <= my; i++)
    {
        int a, b, c;
        cin >> a >> b >> c;
        adjy[a].push_back({b, c});
        adjy[b].push_back({a, c});
    }
}
ll dist[MAXN];
ll dejkstrax()
{
    for (int i = 1; i <= nx; i++)
        dist[i] = INF;
        dist[1] = 0;
        set <pair <ll, int> > s;
        s.insert({0, 1});
        while (!s.empty())
        {
            auto curr = *s.begin();
            s.erase(s.begin());
            for (auto i: adjx[curr.second])
                if (i.second + curr.first < dist[i.first])
            {
                if (dist[i.first] != INF)
                s.erase({dist[i.first], i.first});
                dist[i.first] = i.second + curr.first;
                s.insert({dist[i.first], i.first});
            }
        }
    return dist[nx];
}
ll dejkstray()
{
    for (int i = 1; i <= ny; i++)
        dist[i] = INF;
        dist[1] = 0;
        set <pair <ll, int> > s;
        s.insert({0, 1});
        while (!s.empty())
        {
            auto curr = *s.begin();
            s.erase(s.begin());
            for (auto i: adjy[curr.second])
                if (i.second + curr.first < dist[i.first])
            {
                if (dist[i.first] != INF)
                s.erase({dist[i.first], i.first});
                dist[i.first] = i.second + curr.first;
                s.insert({dist[i.first], i.first});
            }
        }
    return dist[ny];
}
void solve()
{
    if (task == 1)
    {
        cout << dejkstrax() + dejkstray() << endl;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
