#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 53
using namespace std;
typedef long long ll;
typedef long double ld;
int n, k;
int perm[MAXN];
void read()
{
    cin >> n >> k;
    for (int i = 1; i <= n; i++)
        cin >> perm[i];
}
bool check(vector <int> perm)
{
    bool used[MAXN];
    memset(used, false, sizeof(used));
    for (int i = 1; i <= n; i++)
    {
        int pos = perm[i];
        int cnt = 0;
        while (!used[pos])
        {
            used[pos] = true;
            pos = perm[pos];
            cnt++;
        }
        if (cnt && k % cnt)
            return false;
    }
    return true;
}
bool is[MAXN];
void solve()
{
    for (int i = 1; i <= n; i++)
        is[perm[i]] = true;
    vector <int> v;
    for (int i = 1; i <= n; i++)
        if (!is[i])
            v.push_back(i);
    if (v.size() <= 8)
    {
        do
        {
            vector <int> curr;
            curr.resize(n + 1);
            int pos = 0;
            for (int i = 1; i <= n; i++)
            {
                if (perm[i])
                    curr[i] = perm[i];
                else
                {
                    curr[i] = v[pos];
                    pos++;
                }
            }
            if (check(curr))
            {
                for (int i = 1; i <= n; i++)
                    cout << curr[i] << " ";
                cout << endl;
                return;
            }
        }
        while (next_permutation(v.begin(), v.end()));
    }
    else
    {
        for (;;)
        {
            random_shuffle(v.begin(), v.end());
            vector <int> curr;
            curr.resize(n + 1);
            int pos = 0;
            for (int i = 1; i <= n; i++)
            {
                if (perm[i])
                    curr[i] = perm[i];
                else
                {
                    curr[i] = v[pos];
                    pos++;
                }
            }
            if (check(curr))
            {
                for (int i = 1; i <= n; i++)
                    cout << curr[i] << " ";
                cout << endl;
                return;
            }
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
/*
11 42
0 0 9 10 6 1 3 0 11 2 0
*/
