# include <iostream>
# include <bits/stdc++.h>
using namespace std;
vector <pair <int,int> > gx[50005];
vector <pair <int,int> > gy[50005];
struct pipe
{
    int from;
    int to;
    bool fl;
    int w;
};
vector <pipe> r;
pipe r1;
bool visx[50005];
bool visy[50005];
int compx[50005];
int compy[50005];
int nx,mx,ny,my;
long long sum1,sum2;
bool cmp (pipe i, pipe j)
{
    return i.w<j.w;
}
long long dijkstrax()
{
    priority_queue <pair <long long,int> >  q;
    int x,y,i,j;
    int tek;
    long long p,w;
    q.push({0,1});
    while(!q.empty())
    {
        tek = q.top().second;
        p = -q.top().first;
        q.pop();
        if(tek == nx)return p;
        if(visx[tek])continue;
        visx[tek]=1;
        for(i=0;i<gx[tek].size();i++)
        {
            x = gx[tek][i].first;
            if(visx[x])continue;
            q.push({-p-gx[tek][i].second,x});
        }
    }
}
int checkxcomp(int x)
{
    if(compx[x]==x)return x;
    int p = checkxcomp(compx[x]);
    compx[x]=p;
    return p;
}
int checkycomp(int x)
{
    if(compy[x]==x)return x;
    int p = checkycomp(compy[x]);
    compy[x]=p;
    return p;
}
mergexcomp(int x, int y)
{
    if(compx[x]>compx[y])swap(x,y);
    compx[compx[y]] = compx[x];
}
mergeycomp(int x, int y)
{
    if(compy[x]>compy[y])swap(x,y);
    compy[compy[y]] = compy[x];
}
long long solve1()
{
    long long ans = 0;
    sort(r.begin(),r.end(),cmp);
    int i,j,x,y,t;
    int compsx = nx;
    int compsy = ny;
    for(i=1;i<=nx;i++)
        compx[i]=i;
    for(i=1;i<=ny;i++)
        compy[i]=i;
    for(i=0;i<r.size();i++)
    {
        x = r[i].from;
        y = r[i].to;
   //     cout<<x<<" "<<y<<" "<<r[i].fl<<" "<<r[i].w<<" "<<nx<<" "<<ny<<" "<<ans<<endl;
        if(r[i].fl==0)
        {
            if(checkxcomp(x)==checkxcomp(y))continue;
            ans += r[i].w*ny;
            mergexcomp(x,y);
            nx--;
        }
        if(r[i].fl==1)
        {
            if(checkycomp(x)==checkycomp(y))continue;
            ans += r[i].w*nx;
            mergeycomp(x,y);
            ny--;
        }
    }
    return ans;
}
long long dijkstray()
{
    priority_queue <pair <long long,int> >  q;
    int x,y,i,j;
    int tek;
    long long p,w;
    q.push({0,1});
    while(!q.empty())
    {
        tek = q.top().second;
        p = -q.top().first;
        q.pop();
        if(tek == ny)return p;
        if(visy[tek])continue;
        visy[tek]=1;
        for(i=0;i<gy[tek].size();i++)
        {
            x = gy[tek][i].first;
            if(visy[x])continue;
            q.push({-p-gy[tek][i].second,x});
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
int L;
cin>>L;

cin>>nx>>mx;
int i,j,x,y,z;
for(i=1;i<=mx;i++)
{
    cin>>x>>y>>z;
    r1.from = x;
    r1.to = y;
    r1.fl = 0;
    r1.w = z;
  r.push_back(r1);
    gx[x].push_back({y,z});
    gx[y].push_back({x,z});
}
cin>>ny>>my;
for(i=1;i<=my;i++)
{
    cin>>x>>y>>z;
    r1.from = x;
    r1.to = y;
    r1.fl = 1;
    r1.w = z;
    r.push_back(r1);
    gy[x].push_back({y,z});
    gy[y].push_back({x,z});
}
if(L==1)
cout<<dijkstrax()+dijkstray()<<endl;
else
{
cout<<solve1()<<endl;
}
return 0;
}
