#include <bits/stdc++.h>

#define endl '\n'
#define trace(x) cerr << #x << " = " << x <<endl
#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXN = 51;

int n, k;
int p[MAXN];
bool used[MAXN];
vector<int> vals;

int get_place(int idx) {
    return p[idx] < 0 ? vals[-p[idx] - 1] : p[idx];
}

bool ok() {
    int perm[MAXN][2];
    int curr_idx = 0;
    for (int i = 0; i < n; i++) perm[i][curr_idx] = i + 1;
    for (int m = 1; m <= 1; m++) {
        curr_idx ^= 1;
        for (int i = 0; i < n; i++) perm[get_place(i) - 1][curr_idx] = perm[i][curr_idx ^ 1];
    }
    for (int i = 0; i < n; i++) {
        if (perm[i][curr_idx] != i + 1) return false;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int id = 1;
    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> p[i];
        if (!p[i]) {
            p[i] = -id;
            id++;
        }
    }
    memset(used, false, sizeof(used));
    for (int i = 0; i < n; i++) {
        if (p[i] > 0) used[p[i]] = true;
    }
    for (int i = 1; i <= n; i++) {
        if (!used[i]) vals.push_back(i);
    }
    do {
        if (ok()) {
            for (int i = 0; i < n; i++) cout << get_place(i) << " \n"[i == n - 1];
            break;
        }
    } while (next_permutation(all(vals)));

    return EXIT_SUCCESS;
}
