#include <iostream>
#include <set>
#include <ctime>
using namespace std;

const int N=55;

int p[N],temp[10005][N],old[N];
int n,k;
int divisor;
bool used[N];
set <int> st;

bool NoTime()
{
 return clock()/(double)CLOCKS_PER_SEC>0.15;
}

void Check()
{
 int i,moves;
 bool fl;

  for(i=1;i<=n;i++)
   temp[0][i]=i;

 moves=0;
  while(moves<k+1)
  {
   moves++;

   fl=true;
    for(i=1;i<=n;i++)
    {
     temp[moves][p[i]]=temp[moves-1][i];

      if(temp[moves][p[i]]!=p[i])
       fl=false;
    }

    if(fl)
     break;
  }

  if(k%moves==0)
  {
    for(i=1;i<=n;i++)
     cout<<p[i]<<" ";

   cout<<"\n";
   exit(0);
  }
}

void Solve1(int ind)
{
 int i,temp,moves;
 bool valid;

  if(NoTime())
   return;

  if(ind==n+1)
  {
   Check();
   return;
  }

  if(p[ind]!=0)
  {
   Solve1(ind+1);
   return;
  }

 valid=false;
 moves=0;
 temp=ind;
  while(1)
  {
   temp=p[temp];
   moves++;

    if(p[temp]==0)
    {
     valid=true;
     break;
    }

    if(temp==ind)
    {
      if(k%moves==0)
       valid=true;

     break;
    }
  }

  if(!valid)
   return;

  for(i=n;i>=1;i--)
  {
   if(!used[i])
   {
    used[i]=true;
    p[ind]=i;
    Solve1(ind+1);
    p[ind]=0;
    used[i]=false;
   }
  }
}

void Solve2(int ind)
{
 int i,temp,moves;
 bool valid;

  if(ind==n+1)
  {
   Check();
   return;
  }

  if(p[ind]!=0)
  {
   Solve2(ind+1);
   return;
  }

 valid=false;
 moves=0;
 temp=ind;
  while(1)
  {
   temp=p[temp];
   moves++;

    if(p[temp]==0)
    {
     valid=true;
     break;
    }

    if(temp==ind)
    {
      if(k%moves==0)
       valid=true;

     break;
    }
  }

  if(!valid)
   return;

  for(i=1;i<=n;i++)
  {
   if(!used[i])
   {
    used[i]=true;
    p[ind]=i;
    Solve2(ind+1);
    p[ind]=0;
    used[i]=false;
   }
  }
}

int main()
{

ios::sync_with_stdio(false);
cin.tie(nullptr);

int i;

cin>>n>>k;

 for(i=1;i<=n;i++)
 {
  cin>>p[i];
  used[p[i]]=true;
 }

Solve1(1);

Solve2(1);

return 0;
}
